> For the complete documentation index, see [llms.txt](https://docs.openeden.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.openeden.com/usdo/developers/integration-guide.md).

# Integration Guide

### Minting USDO

User can call the [<mark style="color:red;">`instantMint()`</mark>](https://etherscan.io/address/0x80e49d1bdce8f80c38e88dd5c4c004ddb9b4e887#writeProxyContract#F5) function on the USDO token contract. The required asset is USDC, similar to OpenEden's web portal. All existing restrictions such as whitelisted address applies.

### Manual Redemption USDO

User can call the [<mark style="color:red;">`redeem()`</mark>](https://etherscan.io/address/0x80e49d1bdce8f80c38e88dd5c4c004ddb9b4e887#writeProxyContract#F10) function on the USDO token contract. The transaction will be reverted if there is insufficient liquidity available for instant redemption.

### Wrapping USDO

Users can call the [<mark style="color:red;">`deposit()`</mark>](https://etherscan.io/address/0xaD55aebc9b8c03FC43cd9f62260391c13c23e7c0#writeProxyContract#F3) function on the cUSDO token contract to wrap USDO tokens into cUSDO tokens or via OpenEden's USDO web portal’s “Wrap” functionality.

### Unwrapping cUSDO

Users can call the [<mark style="color:red;">`redeem()`</mark>](https://etherscan.io/address/0xaD55aebc9b8c03FC43cd9f62260391c13c23e7c0#writeProxyContract#F10) function on the cUSDO token contract to unwrap cUSDO tokens into USDO tokens or via OpenEden's USDO web portal’s “Unwrap” functionality.

### Calculating Dollar Value of cUSDO Balance

Users can calculate the dollar value of their cUSDO balance by calling the balanceOf() function on the cUSDO token contract and convertToAssets() rate on the cUSDO contract, and multiplying both values together.

cUSDO balance($) = [`balanceOf(userAddress)`](https://etherscan.io/address/0xaD55aebc9b8c03FC43cd9f62260391c13c23e7c0#readProxyContract#F8) \*  [`convertToAssets()`](https://etherscan.io/address/0xaD55aebc9b8c03FC43cd9f62260391c13c23e7c0#readProxyContract#F9)

### Testnet

<table data-header-hidden><thead><tr><th width="170"></th><th width="199"></th><th></th></tr></thead><tbody><tr><td><strong>Token</strong></td><td><strong>Network</strong></td><td><strong>Contract Address</strong></td></tr><tr><td>USDO</td><td>Ethereum Sepolia</td><td><a href="https://sepolia.etherscan.io/address/0x1A09b6C25E02f118bd028024C563e7EADeD64167">0x1A09b6C25E02f118bd028024C563e7EADeD64167</a></td></tr><tr><td>cUSDO</td><td>Ethereum Sepolia</td><td><a href="https://sepolia.etherscan.io/address/0xdee4E3cCC8B450E2b8C9074edE9e981E18860D0c">0xdee4E3cCC8B450E2b8C9074edE9e981E18860D0c</a></td></tr><tr><td>USDO</td><td>Base Sepolia</td><td><a href="https://sepolia.basescan.org/address/0x6dd06bc1bbf8f04807ba7caf663a02a0d10d85b3">0x6dD06bc1bbF8F04807BA7CAf663A02a0D10D85b3</a></td></tr><tr><td>cUSDO</td><td>Base Sepolia</td><td><a href="https://sepolia.basescan.org/address/0xadef03f548993742db8f24f98268b5f30d780edf">0xAdef03f548993742db8F24F98268B5f30D780Edf</a></td></tr></tbody></table>

#### USDO Testnet Faucet

Vist our testnet faucet to begin testing

{% embed url="<https://faucet.openeden.com/usdo>" %}

### Mainnet Access

View the full USDO Contracts here: [Contracts](/usdo/developers/contracts.md)

### Build on USDO

Contact us [here](https://forms.gle/MNuDnyc7WZM9i9s79) if you would like to build on USDO.

\ <br>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.openeden.com/usdo/developers/integration-guide.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
